<?php
/**
 * Scroll article excerpt
 *
 * @package Scroll article excerpt
 * @subpackage Scroll article excerpt
 * @version   3.4
 * @author    Gopi Ramasamy
 * @copyright Copyright (C) 2010 - 2015 www.gopiplus.com, LLC
 * @license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 *
 */
 
// -------------------------------------------------------------------------------------------------------------------
// Lide Demo: http://www.gopiplus.com/extensions/2011/09/scroll-article-excerpt-joomla-module/
// Technical Support: http://www.gopiplus.com/extensions/2011/09/scroll-article-excerpt-joomla-module/
// -------------------------------------------------------------------------------------------------------------------

// no direct access
defined('_JEXEC') or die;

class modScrollArticleExcerpt
{
	public static function loadScripts(&$params)
	{
		$doc = JFactory::getDocument();
		$doc->addScript(JURI::Root(true).'/modules/mod_scroll_article_excerpt/mod_scroll_article_excerpt.js');
	}
	
	public static function getArticleList(&$params)
	{
      	$db			= JFactory::getDBO();
		$user		= JFactory::getUser();
		$userId		= (int) $user->get('id');
		
		$option		= JRequest::getCmd('option');
		$view		= JRequest::getCmd('view');
		
		$temp		= JRequest::getString('id');
		$temp		= explode(':', $temp);
		$id			= $temp[0];
		
		$sae_count 		= (int) $params->get('sae_count', 5);
		$sae_ordering 	= $params->get('sae_ordering');
		$sae_user_id 	= $params->get('sae_user_id', 0);
		$sae_show_front = $params->get('sae_show_front', 1);
		$sae_recent 	= $params->get('sae_recent');
		$sae_cat 		= $params->get('sae_cat', 1);
		$sae_only		= $params->get('sae_only', 0);
		$sae_sccart		= $params->get('sae_show_child_category_articles', 0);
		$sae_levels 	= $params->get('sae_levels', 0); 
		$sae_catexc		= $params->get('sae_catexc', '');
		$sae_text		= (int) $params->get('sae_text', 0);
		$sae_excerpt		= (int) $params->get('sae_excerpt', 150);
		$current		= 1;

		$access 	= !JComponentHelper::getParams('com_content')->get('show_noauth');
		$authorised = JAccess::getAuthorisedViewLevels(JFactory::getUser()->get('id'));
		
		$app = JFactory::getApplication();
		
		$concats = ' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,' .
			' CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE cc.id END as catslug';
			
		$nullDate = $db->getNullDate();

		$date = JFactory::getDate();
		$now = $date->toSql();
		
		$where		= 'a.state = 1'
			. ' AND ( a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )'
			. ' AND ( a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )'
			;
		
		if ( $sae_recent ) :
			$where .= ' AND DATEDIFF('.$db->Quote($now).', a.created) < ' . $sae_recent;
		endif;
		
		if ($app->getLanguageFilter()) 
		{
			$where .= ' AND a.language in ('.$db->quote(JFactory::getLanguage()->getTag()).','.$db->quote('*').')';
		}

		if ( $sae_user_id > 1 && $userId ) 
		{
			switch ($sae_user_id)
			{
				case '2':
					$where .= ' AND (created_by = ' . (int) $userId . ' OR modified_by = ' . (int) $userId . ')';
					break;
				case '3':
					$where .= ' AND (created_by <> ' . (int) $userId . ' AND modified_by <> ' . (int) $userId . ')';
					break;
			}
		}
		
		switch ($sae_ordering)
		{
			case 'random':
				$ordering		= ' ORDER BY rand()';
				break;
			case 'h_asc':
				$ordering		= ' ORDER BY a.hits ASC';
				break;
			case 'h_dsc':
				$ordering		= ' ORDER BY a.hits DESC';
				break;
			case 'm_dsc':
				$ordering		= ' ORDER BY a.modified DESC, a.created DESC';
				break;
			case 'order':
				$ordering		= ' ORDER BY a.ordering ASC';
				break;
			case 'c_dsc':
			default:
				$ordering		= ' ORDER BY a.created DESC';
				break;
		}
		
		$joins = ' INNER JOIN #__categories AS cc ON cc.id = a.catid';
		
		switch ( $sae_show_front )
		{
			case 1:
				$joins .= ' LEFT JOIN #__content_frontpage AS f ON f.content_id = a.id';
				$where .= ' AND f.content_id IS NULL';
				break;
			case 2:
				$joins .= ' LEFT JOIN #__content_frontpage AS f ON f.content_id = a.id';
				$where .= ' AND f.content_id = a.id';
				break;
		}
		
        $catid = $the_id = $catCondition = '';
		
		if ( $sae_only == 0 && $option == 'com_content' && $view == 'category' && $sae_cat ==1 ) 
		{
	    	$catid = $id;
		}
				   
        if ( $option == 'com_content' && $view == 'article' && $id ) 
		{
                $the_id = $id;	
				$article = JTable::getInstance('content');
				$article->load( $id );
   
                if ($current == 0) 
				{
                    $where .= ' AND a.id!='.$the_id;
                }
				if ( $sae_cat == 1 )
				{
					$catid = $article->catid;
				}
				
                if ($sae_user_id == 1)
				{
		            $where .= ' AND created_by = ' . $article->created_by;
				}
        }
		if ($catid) 
		{
			$catCondition .= ' AND (cc.id='. $catid;
			if ($sae_sccart && $sae_levels > 0) 
			{
				$categories = JModelLegacy::getInstance('Categories', 'ContentModel', array('ignore_request' => true));
				$categories->setState('params', $app->getParams());
				$levels = $params->get('sae_levels', 1) ? $params->get('sae_levels', 1) : 9999;
				$categories->setState('filter.get_children', $levels);
				$categories->setState('filter.published', 1);
				$categories->setState('filter.access', $access);
				$additional_catids = array();
				$categories->setState('filter.parentId', $catid);
				$recursive = true;
				$items = $categories->getItems($recursive);
	
				if ($items)
				{
					foreach($items as $category)
					{
						$condition = (($category->level - $categories->getParent()->level) <= $levels);
						if ($condition) {
							$catCondition .= ' OR cc.id='. $category->id;
						}
	
					}
				}
			}
			$catCondition .= ')';
		}
		
		if ( !empty($sae_catexc[0]) ) 
		{
                $catCondition .= ' AND (cc.id!=' . implode( ' AND cc.id!=', $sae_catexc ) . ')';
        }
		
		$query = 'SELECT a.*, cc.title AS catname,' .
			$concats  .
			' FROM #__content AS a' .
			$joins  .
			' WHERE '. $where .
			($access ? ' AND a.access IN ('.implode(',', $user->getAuthorisedViewLevels()).')' : '') .
			$catCondition .
			' AND cc.published = 1' .
			$ordering;
			
		$db->setQuery($query, 0, $sae_count);
		$rows = $db->loadObjectList();
		

		$items	= array();
		$i = 0;
		foreach ( $rows as &$row ) 
		{
		    $link = '';
			$text = '';
			if($sae_text < 2)
			{
		    	$text = $row->introtext;
			}
			
			if($sae_text > 1 || $text == "")
			{
			 	$text =  $row->fulltext;
			}
			$text = modScrollArticleExcerpt::sae_dp_clean($text, $sae_excerpt);
            if ( $the_id != $row->id or $current != 2 ) 
			{
				$link 				= JRoute::_(ContentHelperRoute::getArticleRoute($row->slug, $row->catslug));
				$items[$i]			= new stdClass;
				$items[$i]->links 	= $link;
				$items[$i]->title	= $row->title;
				$items[$i]->text	= $text;
				$i++;
			}
		}
      	return $items;
    }	
	
	
	public static function sae_dp_clean($excerpt, $substr=0) 
	{
		$string = strip_tags(str_replace('[...]', '...', $excerpt));
		$string = str_replace("\r", "", $string);
		$string = str_replace("\n", "", $string);
		if ($substr>0) 
		{
			$string = substr($string, 0, $substr);
		}
		return $string;
	}
}
?>